import * as codedeploy from "aws-cdk-lib/aws-codedeploy";
import * as iam from "aws-cdk-lib/aws-iam";
import * as lambda from "aws-cdk-lib/aws-lambda";
import * as sqs from "aws-cdk-lib/aws-sqs";
import { Construct } from "constructs";
type hardcodedProps = "deadLetterQueue" | "tracing" | "runtime" | "role" | "functionName" | "architecture";
export type LambdaProps = Omit<lambda.FunctionProps, hardcodedProps>;
export interface LambdaBaseProps {
    role?: iam.IRole;
    functionName?: string;
    lambdaProps: LambdaProps;
    deploymentConfig?: codedeploy.ILambdaDeploymentConfig;
    errorThreshold?: number;
    errorEvalPeriods?: number;
    lambdaPolicies?: iam.IManagedPolicy[];
    logLevel?: string;
    provisionedConcurrency?: number;
    throttleThreshold?: number;
}
export declare class LambdaBase extends Construct {
    readonly lambdaFunction: lambda.Function;
    readonly alias: lambda.Alias | undefined;
    readonly executionRole: iam.IRole;
    readonly deadLetterQueue: sqs.Queue;
    constructor(scope: Construct, id: string, props: LambdaBaseProps);
    private createAlarmFromMetric;
}
export {};
