/// <reference types="jasmine" />
import { CloudWatch } from "@aws-sdk/client-cloudwatch";
import { CodePipeline } from "@aws-sdk/client-codepipeline";
import { DynamoDB } from "@aws-sdk/client-dynamodb";
export declare class JsonReporter implements jasmine.CustomReporter {
    private testRunId;
    constructor(testRunId: string);
    jasmineStarted(suiteInfo: jasmine.JasmineStartedInfo): void;
    jasmineDone(doneInfo: jasmine.JasmineDoneInfo): Promise<void>;
    suiteStarted(result: jasmine.SuiteResult): void;
    suiteDone(result: jasmine.SuiteResult): void;
    specStarted(result: jasmine.SpecResult): void;
    specDone(result: jasmine.SpecResult): Promise<void>;
}
export declare class CloudwatchReporter implements jasmine.CustomReporter {
    private readonly cw;
    readonly metricNamesapce: string;
    constructor(metricNamesapce: string, cw: CloudWatch);
    jasmineDone(doneInfo: jasmine.JasmineDoneInfo): Promise<void>;
    specDone(result: jasmine.SpecResult): Promise<void>;
}
export interface DynamoDBReporterProps {
    dynamodb: DynamoDB;
    tableName: string;
    testRunId: string;
    dataRetentionDays?: number;
}
export declare class DynamoDBReporter implements jasmine.CustomReporter {
    private readonly tableName;
    private readonly testRunId;
    private readonly dataRetentionDays;
    private readonly db;
    constructor(props: DynamoDBReporterProps);
    jasmineDone(doneInfo: jasmine.JasmineDoneInfo): Promise<void>;
    private writeDoneInfoToDb;
}
export declare class CodePipelineReporter implements jasmine.CustomReporter {
    private readonly jobId;
    private readonly cp;
    constructor(jobId: string, codepipline: CodePipeline);
    jasmineDone(doneInfo: jasmine.JasmineDoneInfo): Promise<void>;
}
